<template>
  <div>
    <BasicTable @register="registerTable">
      <template #toolbar>
        <Authority value="api:yt:sceneLinkage:post">
          <a-button type="primary" @click="handleAdd"> 新增场景联动 </a-button>
        </Authority>
        <Authority value="api:yt:sceneLinkage:delete">
          <Popconfirm
            title="您确定要批量删除数据"
            ok-text="确定"
            cancel-text="取消"
            @confirm="handleDeleteOrBatchDelete(null)"
          >
            <a-button color="error" :disabled="hasBatchDelete"> 批量删除 </a-button>
          </Popconfirm>
        </Authority>
      </template>
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '查看',
              auth: 'api:yt:sceneLinkage:get',
              icon: 'ant-design:eye-outlined',
              onClick: handleView.bind(null, record),
            },
            {
              label: '编辑',
              auth: 'api:yt:sceneLinkage:update',
              icon: 'clarity:note-edit-line',
              onClick: handleEdit.bind(null, record),
              ifShow: record.creator === userId && record.status !== 1,
            },
          ]"
          :drop-down-actions="[
            {
              label: '删除',
              auth: 'api:yt:sceneLinkage:delete',
              icon: 'ant-design:delete-outlined',
              color: 'error',
              ifShow: record.creator === userId && record.status !== 1,
              popConfirm: {
                title: '是否确认删除',
                confirm: handleDeleteOrBatchDelete.bind(null, record),
              },
            },
          ]"
        />
      </template>

      <template #status="{ record }">
        <Switch
          :checked="record.status === 1"
          :loading="record.pendingStatus"
          checkedChildren="启用"
          unCheckedChildren="禁用"
          @change="(checked:boolean)=>statusChange(checked,record)"
        />
      </template>
    </BasicTable>
    <SceneLinkAgeDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>
<script lang="ts" setup>
  import { nextTick } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useDrawer } from '/@/components/Drawer';
  import {
    screenLinkPageGetApi,
    screenLinkPageDeleteApi,
    screenLinkPagePutApi,
  } from '/@/api/ruleengine/ruleengineApi';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Switch, Popconfirm } from 'ant-design-vue';
  import { columns, searchFormSchema } from './config/config.data';
  import { USER_INFO_KEY } from '/@/enums/cacheEnum';
  import { getAuthCache } from '/@/utils/auth';
  import SceneLinkAgeDrawer from './SceneLinkAgeDrawer.vue';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { Authority } from '/@/components/Authority';

  const userInfo: any = getAuthCache(USER_INFO_KEY);
  const userId = userInfo.userId;

  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerTable, { reload, setProps, setSelectedRowKeys }] = useTable({
    title: '场景联动列表',
    api: screenLinkPageGetApi,
    columns,
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
    },
    useSearchForm: true,
    showTableSetting: true,
    bordered: true,
    showIndexColumn: false,
    actionColumn: {
      width: 200,
      title: '操作',
      dataIndex: 'action',
      slots: { customRender: 'action' },
      fixed: 'right',
    },
  });
  const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions, resetSelectedRowKeys } =
    useBatchDelete(screenLinkPageDeleteApi, handleSuccess, setProps);
  selectionOptions.rowSelection.getCheckboxProps = (record: Recordable) => {
    // Demo:status为1的选择框禁用
    if (record.status === 1) {
      return { disabled: true };
    } else {
      return { disabled: false };
    }
  };
  nextTick(() => {
    setProps(selectionOptions);
  });

  function handleAdd() {
    window.localStorage.setItem('isViewDisabledBtn', 'noView');
    openDrawer(true, {
      isUpdate: false,
    });
  }

  function handleEdit(record: Recordable) {
    window.localStorage.setItem('isViewDisabledBtn', 'noView');
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  }
  function handleView(record: Recordable) {
    window.localStorage.setItem('isViewDisabledBtn', 'isView');
    openDrawer(true, {
      record,
      isUpdate: 3,
    });
  }
  function handleSuccess() {
    reload();
  }

  const statusChange = async (checked, record) => {
    setProps({
      loading: true,
    });
    setSelectedRowKeys([]);
    resetSelectedRowKeys();
    const newStatus = checked ? 1 : 0;
    const { createMessage } = useMessage();
    try {
      await screenLinkPagePutApi({ id: record.id, status: newStatus });
      if (newStatus) {
        createMessage.success(`启用成功`);
      } else {
        createMessage.success('禁用成功');
      }
    } finally {
      setProps({
        loading: false,
      });
      reload();
    }
  };
</script>
